# Local Development

## Background
This workflow can replace the docker-compose in geomag-stacks. This docker-compose uses the existing Dockerfile to create a `localdev-web-1` container, instead of pulling down the latest geomag-algorithms image. However, it is initializing the mysql database the same way it is done in geomag-stacks. This docker-compose is also creating a mysql container called `localdev-database-1` an edge container called `localdev-edge-1` using the geomag-edge Dockerfile in geomag-stacks. The geomag-edge folder was not moved out of geomag-stacks out of an abudance of caution to prevent internal information from being revealed.

## Prerequisites
For mac development:
1. Download colima using homebrew.
2. Start colima and edit virtual machine sizes using `colima start --edit`. Increase the number of CPUs to 16 and the memory to 16.
3. Add the following env vars to your .bashrc or .zshrc. Replace the EDGE_PATH and 
EDGE_DATA_PATH with the absolute path to your geomag-stack. See the instructions in metadata_webservice.md for instructions on creating the OPENID_CLIENT_ID and
OPENID_CLIENT_SECRET. The rest of the values can be found in the geomag-stack docker-compose. Run the source command to pick up the new values (ex `source ~/.bashrc`).
```
export EDGE_PATH="/Users/{user}/geomag-stack/geomag-edge"
export EDGE_DATA_PATH="/Users/{user}/geomag-stack/edge-data"
export OPENID_CLIENT_ID=""
export OPENID_CLIENT_SECRET=""
export DATABASE_URL=""
export OPENID_METADATA_URL=""
export SECRET_KEY=""
export SECRET_SALT=""
export MYSQL_ROOT_PASSWORD=""
```

## Use
To simply start build and run all the containers, make sure you are in the /localdev directory and run the following command. This includes a reload command for the web container. It will restart the web container when changes are made locally.
```
docker-compose up
```

If you're not developing locally, use the following command to run the containers in the background. Reload will not work this way.
```
docker-compmose up -d 
```

## Helpful Docker Commands
`docker ps` shows the running containers. 

`docker ps -a` shows all the containers, even ones that have exited. This is helpful to see logs for containers that have unexpectedly exited.

`docker exec -it {CONTAINER ID} /bin/bash` execs into the container. This can be helpful for exploring the mysql db. After you exec into the mysql container, run `mysql -u root -p` in the container. Input the password you set to MYSQL_ROOT_PASSWORD. Now
you can use SQL to explore the db.

## Helpful Tips
Sometimes the mysql container exits immediately with code 139 due to insufficient memory. Restarting colima resolves this issue.
